/*
 * uninitialized.cpp
 *
 * @author Cynthia Lee
 * @version 2122-Aut
 *
 * Just prints out some uninitialized memory. It's like opening a present, you
 * never know what you're going to get! #Surprise #NotAVeryGoodPresentThough
 */

#include <iostream>
#include "console.h"
#include "simpio.h"
using namespace std;

const int    ARRAY_SIZE = 9;

int  guessContentsOfUninitializedMemory();
bool checkGuess(int guess, int answer);


/*
 * Let's print some uninitialized memory!
 * Professional coder on a closed course. Do not try this at home.
 */
int main() {
    cout << "Guess numbers between -2147483647 and +2147483647" << endl << endl;

    int nCorrect = guessContentsOfUninitializedMemory();

    if (((double)nCorrect) == (ARRAY_SIZE + 1)) {
        cout << "Wow!!! Great guessing!!" << endl;
    } else {
        cout << "You made " << nCorrect << " correct guesses. "
             << "Better luck next time." << endl;
    }
    return 0;
}

/*
 * Quick demo to show that both stack and heap memory can be uninitialized
 * and if we print the contents we see a "random"/garbage value.
 *
 * @return number of correct guesses of the random/garbage value.
 */
int guessContentsOfUninitializedMemory()
{
    int nCorrect = 0;

    /* show that local variables (stack memory) can be uninitialized */
    int x;
    int guess = getInteger("Guess the value of x: ");
    if (checkGuess(guess, x)) {
        nCorrect++;
    }
    /* show that dynamically allocated arrays (heap memory) can be uninitialized */
    int* arr = new int[ARRAY_SIZE];
    for (int i = 0; i < ARRAY_SIZE; i++) {
        cout << "Now guess what number is in arr[" << i << "]: ";
        int guess = getInteger();
        if (checkGuess(guess, arr[i])) {
            nCorrect++;
        }
    }
    delete [] arr;

    return nCorrect;
}


bool checkGuess(int guess, int answer)
{
    if (guess == answer) {
        cout << "You guessed correctly!" << endl << endl;
        return true;
    } else {
        cout << "Sorry, the correct answer was " << answer << endl << endl;
        return false;
    }
}
